<?php
// This file is part of Moodle - http://moodle.org/
//
// Moodle is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// Moodle is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with Moodle.  If not, see <http://www.gnu.org/licenses/>.


/**
 * Learn360 Video filter plugin.
 * @Author    Pramod Ubbala (AGS -> Infobase)
 * @package    filter_learn360
 * @license    http://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later
 */

defined('MOODLE_INTERNAL') || die();

//require_once(dirname(dirname(dirname(__FILE__))) . '/repository/lib.php');

class filter_learn360 extends moodle_text_filter {
  
  private $embedmarkers;

  public function filter($text, array $options = array()) {
    global $CFG, $PAGE;

	//check to see if the text needs to be decoded
//	while(stripos($text, '.infobase.com') === false)
	//loop as long as there's an a tag.  If the a tag is not infobase break the loop

	$dom = new DOMDocument();
	$dom->loadHTML($text);
	$el = $dom->getElementsByTagName('a');

	//foreach($el as $node) {
	//	$a = $dom->saveHTML($node);
		//echo "<script>console.log(".$a.")</script>";
	//}

	//while(stripos($text, '<a') !== false)
	foreach($el as $node)
	{
		$a = $dom->saveHTML($node);

		//echo "<script>console.log(".$a.")</script>";

		preg_match("/<a\s+(?:[^>]*?\s+)?href=\"([^\"]*)\"/", $a, $b64text);

		//echo "<script>console.log(".$b64text[1].")</script>";

		try
		{
			$obj = json_encode(base64_decode($b64text[1]),true);
			 $results = print_r($obj, true);
			$temp=json_decode($results, true);

			$newtext = json_decode($temp,true);
		}
		catch(Exception $e)
		{
			continue;
		}

		
		//if our url doesn't need to be encoded, set it to the OG
		if($newtext['url'] == '')
		{
			$newtext['url'] = $b64text[1];
			//echo "<script>console.log(".$newtext['url'].")</script>";
		}

		//only do this if it's our url
		if(stripos($newtext['url'], '.infobase.com') !== false)
		{
			$text=str_replace($b64text[1],$newtext['url'],$text);

			$a = str_replace($b64text[1],$newtext['url'],$a);

			//get the substring of the url with moodle/ so we can decode it to match the actual text
			if(stripos($newtext['url'], 'moodle/') !== false)
			{
				$moodleText = substr($newtext['url'], stripos($newtext['url'], 'moodle/') + 7, strlen($newtext['url']) - stripos($newtext['url'], 'moodle/') + 7);

				$a = str_replace("moodle/". $moodleText, "moodle/". urldecode($moodleText), $a);
			}

			if (!is_string($text) or empty($text)) {
				// non string data can not be filtered anyway
				//echo "<script>console.log(".$text.")</script>";
				return $text;
			}

			if (stripos($text, '</a>') === false) {
			// Performance shortcut - if not </a> tag, nothing can match.
				//echo "<script>console.log(".$text.")</script>";
				return $text;
			}

			$this->embedmarkers = 'lti\.films\.com|localhost|\.mp4';

			$this->trusted = !empty($options['noclean']) or !empty($CFG->allowobjectembed);

			/*$newtext = preg_replace_callback($re = '~<a\s[^>]*href="([^"]*(?:' .
				$this->embedmarkers . ')[^"]*)"[^>]*">([^>]*)</a>~is',
				array($this, 'callback'), $text);*/

			//preg_match("/<a\s+(?:[^>]*?\s+)?href=\"([^\"]*)\"/", $text, $newtext);
			//preg_match("/<a\s+(?:[^>]*?\s+)?href=\"([^\"]*)\">([^\"<]*)<\/a>/", $a, $newtext);

//			echo "<script>console.log(".$newtext['url'].")</script>";

			//$text=$newtext;

			$width =  435;
			$height = 382;

//echo "<script>console.log(".$newtext['url'].")</script>";

			if(strpos($newtext['url'], '&w=') !== false)
			{
				$dims = substr($newtext['url'], strpos($newtext['url'], '&w='), strlen($newtext['url']) - strpos($newtext['url'], '&w='));

				$width = substr($dims, strpos($dims, '&w=') + 3, strpos($dims, '&h')-3) + 20;
				$height = substr($dims, strpos($dims, '&h=') + 3, strlen($dims) -strpos($dims, '&h=') + 3) + 50;

				//echo "<script>console.log(".$height.")</script>";
			}

			if(strpos($newtext['url'], '.infobase.com') !== false) {

				$iframeText = '<iframe src="' . $newtext['url'] . '" frameborder="0" style="width: ' . $width . 'px;height:' . $height . 'px;" allowfullscreen></iframe>';

				$text = str_replace($a, $iframeText, $text);

				//echo "<script>console.log(".$text.")</script>";
			}

			if (empty($newtext) or $newtext === $text) {
				//echo "<script>console.log(".$text.")</script>";
				// error or not filtered
				continue;
			}		
 		//$text = encodeURLs($text, $options);
//		echo "<script>console.log(".$text.")</script>";
		//echo "<script>console.log(".$newtext['url'].")</script>";
		//echo "<script>console.log(".$b64text[1].")</script>";
		//echo "<br/><script>console.log(".json_encode($text).")</script>";
		}
		//else
		//{
		//	break;
			//echo "<script>console.log(".$text.")</script>";
		//}

	}

    
	return $text;	
  }

  function encodeURLs($text, array $options = array())
	{
		if (!is_string($text) or empty($text)) {
		// non string data can not be filtered anyway
			return $text;
		}

		if (stripos($text, '</a>') === false) {
		// Performance shortcut - if not </a> tag, nothing can match.
			return $text;
		}

		$this->embedmarkers = 'lti\.films\.com|localhost|\.mp4';

		$this->trusted = !empty($options['noclean']) or !empty($CFG->allowobjectembed);

		/*$newtext = preg_replace_callback($re = '~<a\s[^>]*href="([^"]*(?:' .
			$this->embedmarkers . ')[^"]*)"[^>]*">([^>]*)</a>~is',
			array($this, 'callback'), $text);*/

		//preg_match("/<a\s+(?:[^>]*?\s+)?href=\"([^\"]*)\"/", $text, $newtext);
		preg_match("/<a\s+(?:[^>]*?\s+)?href=\"([^\"]*)\">([^\"<]*)<\/a>/", $text, $newtext);

		//echo "<script>console.log(".$newtext[0].")</script>";

		//$text=$newtext;

		$width =  435;
		$height = 382;

		if(strpos($newtext[1], '&w=') !== false)
		{
			$dims = substr($newtext[1], strpos($newtext[1], '&w='), strlen($newtext[1]) - strpos($newtext[1], '&w='));

			$width = substr($dims, strpos($dims, '&w=') + 3, strpos($dims, '&h')-3) + 20;
			$height = substr($dims, strpos($dims, '&h=') + 3, strlen($dims) -strpos($dims, '&h=') + 3) + 50;

			//echo "<script>console.log(".$height.")</script>";
		}

		if(strpos($newtext[1], '.infobase.com') !== false) {

			$iframeText = '<iframe src="' . $newtext[1] . '" frameborder="0" style="width: ' . $width . 'px;height:' . $height . 'px;" allowfullscreen></iframe>';

			$text = str_replace($newtext[0], $iframeText, $text);

			//echo "<script>console.log(".$text.")</script>";
		}

		if (empty($newtext) or $newtext === $text) {
			// error or not filtered
			return $text;
		}

		return $text;
	}
  
  /**
     * Replace link with embedded content, if supported.
     *
     * @param array $matches
     * @return string
     */
    private function callback(array $matches) {
        global $CFG, $PAGE;
        
        // Get name.
        $name = trim($matches[2]);
        if (empty($name) or strpos($name, 'http') === 0) {
            $name = ''; // Use default name.
        }

        $width =  364;
        $height = 300;
       
        /*$result = '<iframe src="' . $matches[1] . '" frameborder="0" style="width: ' . $width . 'px;height:' . $height . 'px;" allowfullscreen></iframe>';*/



		$result = $matches[1];
		

		
        // If something was embedded, return it, otherwise return original.
        if ($result !== '') {
            return $result;
        } else {
            //return $obj[0];
            return $matches[0];
        }
    }

}
